Imports System.IO
Imports System.Web.Mail

Public Class ErrorMailModuleExtension
    Inherits ErrorMailModule

    Private _mailUserName As String
    Private _mailPassword As String
    Private _mailSMTPServer As String
    Private _mailSMTPPort As Integer

    Overrides Sub Init(ByVal application As System.Web.HttpApplication)
        ' call the base class 
        MyBase.Init(application)

        ' get the config
        Dim config As IDictionary = GetConfig()
        If config Is Nothing Then
            Return
        End If

        ' get the required variables from the config and set the local variables
        Dim mailUserName As String = IIf(config.Contains("userName"), config("userName"), String.Empty)
        Dim mailPassword As String = IIf(config.Contains("password"), config("password"), String.Empty)
        Dim mailSMTPServer As String = IIf(config.Contains("smtpServer"), config("smtpServer"), String.Empty)
        Dim mailSMTPPort As Integer = Convert.ToInt32(Convert.ToUInt16(IIf(config.Contains("smtpPort"), config("smtpPort"), "25")))

        _mailUserName = mailUserName.Trim()
        _mailPassword = mailPassword.Trim()
        _mailSMTPServer = mailSMTPServer.Trim()
        _mailSMTPPort = mailSMTPPort

    End Sub

    Protected Overrides Sub PreSendMail(ByVal mail As System.Web.Mail.MailMessage, ByVal er As GotDotNet.Elmah.Error)
        MyBase.PreSendMail(mail, er)

        ' make sure that the user has supplied a username and password
        If _mailUserName.Length > 0 AndAlso _mailPassword.Length > 0 Then
            mail.Fields.Add("http://schemas.microsoft.com/cdo/configuration/smtpauthenticate", 1)
            mail.Fields.Add("http://schemas.microsoft.com/cdo/configuration/sendusername", _mailUserName)
            mail.Fields.Add("http://schemas.microsoft.com/cdo/configuration/sendpassword", _mailPassword)
        End If

        If _mailSMTPServer.Length > 0 Then
            mail.Fields.Add("http://schemas.microsoft.com/cdo/configuration/sendusing", 2)
            mail.Fields.Add("http://schemas.microsoft.com/cdo/configuration/smtpserver", _mailSMTPServer)
            mail.Fields.Add("http://schemas.microsoft.com/cdo/configuration/smtpserverport", _mailSMTPPort)
        End If

        mail.Priority = MailPriority.High

    End Sub

End Class